VERSION 5.00
Begin VB.Form Form1 
   BackColor       =   &H8000000B&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Bare Bones Basic Specrum Display"
   ClientHeight    =   1635
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   9045
   Icon            =   "SpecDisplay.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   1635
   ScaleWidth      =   9045
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton Command2 
      Caption         =   ""
      Height          =   375
      Left            =   2400
      TabIndex        =   6
      Top             =   840
      Width           =   1335
   End
   Begin VB.CommandButton Command1 
      Caption         =   ""
      Height          =   375
      Left            =   480
      TabIndex        =   5
      Top             =   840
      Width           =   1575
   End
   Begin VB.TextBox Text1 
      Height          =   285
      Left            =   2520
      TabIndex        =   4
      Text            =   "Text1"
      Top             =   360
      Width           =   2415
   End
   Begin VB.HScrollBar scrBrightness 
      Height          =   255
      LargeChange     =   10
      Left            =   1080
      Max             =   100
      Min             =   1
      TabIndex        =   3
      Top             =   240
      Value           =   20
      Width           =   1335
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   1
      Left            =   6480
      Top             =   240
   End
   Begin VB.CommandButton CmdSwitch 
      Caption         =   "Freeze"
      Default         =   -1  'True
      Height          =   255
      Left            =   5040
      TabIndex        =   0
      Top             =   360
      Width           =   1335
   End
   Begin VB.Label Label2 
      Caption         =   " "
      Height          =   255
      Left            =   5040
      TabIndex        =   7
      Top             =   0
      Width           =   1335
   End
   Begin VB.Label lblBrightness 
      Alignment       =   2  '
      Caption         =   "Brightness"
      Height          =   735
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   975
   End
   Begin VB.Label Label1 
      Alignment       =   2  '
      Height          =   255
      Left            =   1920
      TabIndex        =   1
      Top             =   3840
      Width           =   1815
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Bare Bone's Basic Spectrum Display
'Adapted from and using the core code
'of a simple spectrum analyser
'taken from the site listed below.
'Code for waterfall display and control
'plus some additional code comments
'added by Michael 'Bear' Hebert NH7SR

'email: takisfmf@yahoo.gr
'for more source code visit
'http://www.geocities.com/takisfmf/index.html

Option Explicit
Const contrast = 6
      Const gain = 6
   Const SampleRate = 48000
   Const bins = 2048
Dim N As Integer        'Number of points in the DFT,
Dim REX() As Double     'Real part of input
Dim IMX() As Double     'Imaginary part of input
Dim ln As Single        'Vertical line # in Waterfall
Dim Volume As Double
Dim curSample As Long

Dim brightness As Integer

Dim scet As Long


Dim fError As Boolean






Private Sub Command1_Click()
 Command1.Enabled = True
   Command2.Enabled = False
End Sub

Private Sub Command2_Click()
Command1.Enabled = False
Command2.Enabled = True
End Sub

Private Sub Form_Activate()

    N = 2048   'Number of samples must be  2^k  where k = integer > 1
    BUFFER_SIZE = 4096      'Must be at least 2 * max number of bins
  
    ReDim REX(N - 1) As Double, IMX(N - 1) As Double
 
    CmdSwitch.Caption = "Start"
  
    lblBrightness.Caption = "Brightness " + Str(scrBrightness.Value)
    brightness = scrBrightness.Value
   
    ln = 0  'Waterfall must start at line 0
    
    Timer1.Interval = 1
    Timer1.Enabled = True
 
    

End Sub


Private Sub CmdSwitch_Click()
    If CmdSwitch.Caption = "Start" Then
        CmdSwitch.Caption = "Freeze"
        StartInput
    Else
        CmdSwitch.Caption = "Start"
        StopInput
    End If

End Sub



Private Sub scrBrightness_Change()
    lblBrightness.Caption = "Brightness " + Str(scrBrightness.Value)
    brightness = scrBrightness.Value
End Sub

Private Sub Timer1_Timer()   ' Process sound buffer if recording
    
    If (fRecording) Then
        If inHdr.dwFlags And WHDR_DONE Then
            rc = waveInAddBuffer(hWaveIn, inHdr, Len(inHdr))
            DrawSpectrum
        End If
        
    End If
        
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    If (fRecording) Then
        StopInput
    End If
End Sub

 Sub DrawSpectrum()
  
    'Dim Volume As Double
    'Dim curSample As Long
    Dim drawflag, f, kk
    N = 2048

    
    For curSample = 0 To 2047
        GetMono16Sample curSample, Volume
        REX(curSample) = Volume
        
        IMX(curSample) = 0
    Next
   
    FFT N, REX, IMX

    
    For f = 0 To 1024
        kk = Sqr(REX(f) ^ 2) * Int((brightness * 100))
        If kk < 1 Then
            kk = 1
        End If
        kk = gain * Log(kk)
         Text1.Text = CStr(kk)
         
    Next
    If kk > 16 Then 'StopInput
          
           scet = scet + 1
          Command1_Click
          Command1.Caption = CStr(scet)
          'Else
          'Command2_Click
          
          End If
End Sub


